unit hiSharedStream;

interface

uses Windows,Kol,Share,Debug;

type
 TStreamEx = {$ifndef F_P}object{$else}class{$endif}(TStream) end;
 PStreamEx = {$ifndef F_P}^{$endif}TStreamEx;
 
type
  ThiSharedStream = class(TDebug)
   private
     hMMF:THandle;
     hFile:THandle;
     ST:PSTreamEx;
     Offset:int64;
     SzFile:int64;
     sinf:_SYSTEM_INFO;
     Size:integer;
//     Size:integer;
//     Offset:real;
     procedure Close;
   public
     _prop_FileName: string;
     _prop_CoreName: string;
     _prop_Offset: real;
     _prop_Size: integer;
     _data_Offset: THI_Event;
     _data_Size: THI_Event;
     _data_FileName: THI_Event;
     _data_CoreName: THI_Event;

//    constructor Create;
    destructor Destroy; override;
    procedure _work_doOpen(var _Data:TData; Index:word);
    procedure _work_doClose(var _Data:TData; Index:word);
    procedure _work_doRemapping(var _Data:TData; Index:word);
    procedure _var_Memory(var _Data:TData; Index:word);
    procedure _var_Stream(var _Data:TData; Index:word);
    procedure _var_SizeMMF(var _Data:TData; Index:word);
  end;

implementation

function GetFileSizeEx(hFile: THandle; var Size: int64): BOOL;
         stdcall; external 'kernel32.dll' name 'GetFileSizeEx';

//const Size = 10000000;

function WriteExMemoryStream( Strm: PStream; var Buffer; Count: DWORD ): DWORD;
asm
        PUSH     EBX
        XCHG     EBX, EAX
        MOV      EAX, [EBX].TStreamEx.fData.fSize
        SUB      EAX, [EBX].TStreamEx.fData.fPosition
        CMP      EAX, ECX
        JGE      @@1
        XCHG     ECX, EAX
@@1:
        MOV      EAX, [EBX].TStreamEx.fMemory
        ADD      EAX, [EBX].TStreamEx.fData.fPosition
        XCHG     EDX, EAX
        PUSH     ECX
        CALL     System.Move
        POP      EAX
        ADD      [EBX].TStreamEx.fData.fPosition, EAX
        POP      EBX
end;

function SeekExMemStream( Strm: PStream; MoveTo: Integer; MoveFrom: TMoveMethod ): DWORD;
asm
        PUSH     EBX
        MOV      EBX, EAX
        MOV      EAX, EDX
        AND      ECX, $FF
        LOOP     @@1
        ADD      EAX, [EBX].TStreamEx.fData.fPosition
@@1:    LOOP     @@2
        ADD      EAX, [EBX].TStreamEx.fData.fSize
@@2:    CMP      EAX, [EBX].TStreamEx.fData.fSize
        JLE      @@3
        MOV      EAX, [EBX].TStreamEx.fData.fSize
@@3:    MOV      [EBX].TStreamEx.fData.fPosition, EAX
        POP      EBX
end;

var SharedMethods: TStreamMethods = (
    fSeek: SeekExMemStream;
    fGetSiz: GetSizeMemStream;
    fSetSiz: DummySetSize;
    fRead: ReadMemStream;
    fWrite: WriteExMemoryStream;
    fClose: DummyStreamProc;
    fCustom: nil;
    fWait: nil;
  );

//constructor ThiSharedStream.Create;
//begin
//  inherited;
//end;

destructor ThiSharedStream.Destroy;
begin
  Close;
  CloseHandle(hMMF);
  CloseHandle(hFile);  
  inherited;
end;

function just(sz:integer):integer;
begin
   if Sz > $FFFF + 1 then
      Result := Sz and $FFFF0000
   else   
      Result := $FFFF + 1;  
end;

procedure ThiSharedStream._work_doOpen;
var   P:Pointer;
      fn, crn:string;
      SzOff: int64;      
begin
   Close;
   GetSystemInfo(sinf);
   fn     := ReadString(_Data,_data_FileName,_prop_FileName);
   crn    := ReadString(_Data,_data_CoreName,_prop_CoreName);  
   Offset := Round(ReadReal(_Data,_data_Offset,_prop_Offset)) and $FFFFFFFFFFFF0000;
   Size   := ReadInteger(_Data,_data_Size,_prop_Size);

   if (fn <> '') and FileExists(fn) then begin
      hFile := CreateFile( PChar(fn), GENERIC_READ OR GENERIC_WRITE,
                           FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0); 
      GetFileSizeEx(hFile, SzFile);
      hMMF := CreateFileMapping(hFile, nil, PAGE_READWRITE, 0, 0, PChar(crn));

      if (I64(SzFile).Hi > 0) or (I64(SzFile).Lo > $7FFFFFFF) then
         Size := just(Size)
      else            
         Size := min(just(Size), I64(SzFile).Lo);  
      SzOff := SzFile - Offset; 
      if SzOff < Size then Size := I64(SzOff).Lo; 
   end else begin
      hFile := INVALID_HANDLE_VALUE;
      Offset := 0;
      Size := just(Size);
      hMMF := CreateFileMapping(hFile, nil, PAGE_READWRITE, 0, Size, PChar(crn));
   end;
   CloseHandle(hFile);
   if hMMF = 0 then exit;
   P := MapViewOfFile(hMMF, FILE_MAP_WRITE, I64(Offset).Hi, I64(Offset).Lo, Size);
   if P = nil then exit;
   ST := PStreamEx(_NewStream(SharedMethods));
   ST.fMemory := P;
   ST.fData.fCapacity := Size;
   ST.fData.fSize     := Size;
end;

procedure ThiSharedStream._work_doRemapping;
var   P:Pointer;
      SzOff: int64;
begin
   if (hFile = INVALID_HANDLE_VALUE) or (hMMF = 0) then exit;
   Offset := Round(ReadReal(_Data,_data_Offset,_prop_Offset)) and $FFFFFFFFFFFF0000;
   Size   := ReadInteger(_Data,_data_Size,_prop_Size);
   if (I64(SzFile).Hi > 0) or (I64(SzFile).Lo > $7FFFFFFF) then
      Size := just(Size)
   else            
      Size := min(just(Size), I64(SzFile).Lo);     
   SzOff := SzFile - Offset; 
   if SzOff < Size then Size := I64(SzOff).Lo;  

   UnmapViewOfFile(ST.fMemory);
   free_and_nil(ST);
   P := MapViewOfFile(hMMF, FILE_MAP_WRITE, I64(Offset).Hi, I64(Offset).Lo, Size);
   if P = nil then exit;
   ST := PStreamEx(_NewStream(SharedMethods));
   ST.fMemory := P;
   ST.fData.fCapacity := Size;
   ST.fData.fSize     := Size;
end;

procedure ThiSharedStream._work_doClose;
begin
   Close;
end;

procedure ThiSharedStream._var_Stream;
begin
   if St = nil then exit;
   dtStream(_Data, ST)
end;

procedure ThiSharedStream._var_SizeMMF;
begin
   if St = nil then exit;
   dtInteger(_Data,ST.Size);
end;

procedure ThiSharedStream._var_Memory;
begin
   if St = nil then exit;
   dtInteger(_Data,integer(ST.Memory));
end;

procedure ThiSharedStream.Close;
begin
   CloseHandle(hFile);
   CloseHandle(hMMF);
   if ST = nil then exit;
   UnmapViewOfFile(ST.fMemory);
   free_and_nil(ST);
end;

end.